%define attica_ver 0.4.0
%define dbusmenu_qt_ver 0.9.0
%define phonon_ver 4.6.0
%define qt4_ver 4.8.1
%define shared_desktop_ontologies_ver 0.10.0
%define soprano_ver 2.8.0
%define strigi_ver 0.7.0
%define webkit 1
%define udisks udisks2
%define udisks2 1
%define upower 1

%global phonon_version %(pkg-config --modversion phonon 2>/dev/null || echo %{phonon_ver})
%global shared_desktop_ontologies_version %(pkg-config --modversion shared-desktop-ontologies 2>/dev/null || echo %{shared_desktop_ontologies_ver})
%global soprano_version %(pkg-config --modversion soprano 2>/dev/null || echo %{soprano_ver})
%global strigi_version %(pkg-config --modversion libstreams 2>/dev/null || echo %{strigi_ver})
%global dbusmenu_qt_version %(pkg-config --modversion dbusmenu-qt 2>/dev/null || echo %{dbusmenu_qt_ver})

Summary: KDE WebKit support library
Name:    kdelibs-webkit
Epoch:   6
# shipped with kde applications, version...
%global apps_version 15.04.1
Version: 4.14.8
Release: 1%{?dist}

# http://techbase.kde.org/Policies/Licensing_Policy
License: LGPLv2+
URL:     http://www.kde.org/
%global revision %(echo %{version} | cut -d. -f3)
%if %{revision} >= 50
%global stable unstable
%else
%global stable stable
%endif
Source0: http://download.kde.org/%{stable}/applications/%{apps_version}/src/kdelibs-%{version}.tar.xz

# hack kdewidgets/CMakeLists.txt: only install kdewebkitwidets and kill rpath with fire
Patch1: kdelibs-4.10.5-kdewebkitwidgets.patch

BuildRequires: kde4-macros(api) >= 2
BuildRequires: kde-filesystem >= 4-23
# for the RPM dependency generators
BuildRequires: kde-settings
BuildRequires: docbook-dtds docbook-style-xsl
BuildRequires: qt4-devel >= %{qt4_ver}
%if 0%{?webkit}
BuildRequires: pkgconfig(QtWebKit)
%endif
%{?_qt4_version:Requires: qt4%{?_isa} >= %{_qt4_version}}

BuildRequires: automoc4 >= 0.9.88
BuildRequires: bison flex
BuildRequires: bzip2-devel
BuildRequires: cmake
BuildRequires: cups-devel cups
BuildRequires: gettext-devel
BuildRequires: giflib-devel
BuildRequires: grantlee-devel
BuildRequires: krb5-devel
BuildRequires: libacl-devel libattr-devel
BuildRequires: libjpeg-devel
BuildRequires: libpng-devel
BuildRequires: libutempter-devel
# strictly only a runtime dependency, but makes cmake happier at buildtime too -- rex
BuildRequires: media-player-info
BuildRequires: pkgconfig(alsa)
BuildRequires: pkgconfig(avahi-core)
BuildRequires: pkgconfig(dbusmenu-qt)
BuildRequires: pkgconfig(enchant)
BuildRequires: pkgconfig(gamin)
BuildRequires: pkgconfig(jasper)
BuildRequires: pkgconfig(libattica) >= %{attica_ver}
BuildRequires: pkgconfig(liblzma)
BuildRequires: pkgconfig(libpcre)
BuildRequires: pkgconfig(libstreams) >= %{strigi_ver}
BuildRequires: pkgconfig(libudev)
BuildRequires: pkgconfig(libxslt) pkgconfig(libxml-2.0)
BuildRequires: pkgconfig(OpenEXR)
BuildRequires: pkgconfig(openssl)
BuildRequires: pkgconfig(phonon) >= %{phonon_ver} 
BuildRequires: pkgconfig(polkit-qt-1)
BuildRequires: pkgconfig(qca2)
BuildRequires: pkgconfig(shared-desktop-ontologies) >= %{shared_desktop_ontologies_ver} 
BuildRequires: pkgconfig(shared-mime-info)
BuildRequires: pkgconfig(soprano) >= %{soprano_ver}
BuildRequires: pkgconfig(zlib)
# extra X deps (seemingly needed and/or checked-for by most kde4 buildscripts)
%define x_deps pkgconfig(sm) pkgconfig(xcomposite) pkgconfig(xdamage) pkgconfig(xkbfile) pkgconfig(xpm) pkgconfig(xproto) pkgconfig(xscrnsaver) pkgconfig(xtst) pkgconfig(xv) pkgconfig(xxf86misc)
%{?x_deps:BuildRequires: %{x_deps}}

%description
KDE WebKit support library.

%package devel
Summary:   Development files for KDE WebKit support library
Provides:  kdelibs4-webkit-devel = %{version}-%{release}
%{?_isa:Provides: kdelibs4-webkit-devel%{?_isa} = %{version}-%{release}}
Requires: %{name}%{?_isa} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires: kdelibs4-devel
Requires: pkgconfig(QtWebKit)
%description devel
%{summary}.


%prep
%setup -q -n kdelibs-%{version}

%patch1 -p1 -b .kdewebkitwidgets


%build
mkdir %{_target_platform}
pushd %{_target_platform}
%{cmake_kde4} \
  -DKAUTH_BACKEND:STRING="PolkitQt-1" \
  -DKDE_DISTRIBUTION_TEXT="%{version}-%{release}%{?fedora: Fedora}%{?rhel: Red Hat Enterprise Linux}" \
  %{?udisks2:-DWITH_SOLID_UDISKS2:BOOL=ON} \
  ..
popd

make %{?_smp_mflags} -C %{_target_platform}/kdewebkit/
make %{?_smp_mflags} -C %{_target_platform}/kdewidgets/

%install
make install/fast DESTDIR=%{buildroot} -C %{_target_platform}/kdewebkit/
make install/fast DESTDIR=%{buildroot} -C %{_target_platform}/kdewidgets/

# move devel symlinks
mkdir -p %{buildroot}%{_kde4_libdir}/kde4/devel
pushd %{buildroot}%{_kde4_libdir}
for i in lib*.so
do
  case "$i" in
    libkdeinit4_*.so)
      ;;
    *)
      linktarget=`readlink "$i"`
      rm -f "$i"
      ln -sf "../../$linktarget" "kde4/devel/$i"
      ;;
  esac
done
popd

## HACK
# kdewebkit target is not defined in kdelibs' KDELibs4LibraryTargets.cmake,
# so apps end up trying to link -lKDE4__kdewebkit instead
ln -s libkdewebkit.so %{buildroot}%{_kde4_libdir}/kde4/devel/libKDE4__kdewebkit.so


%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%{_kde4_libdir}/libkdewebkit.so.5*
%{_kde4_libdir}/kde4/plugins/designer/kdewebkitwidgets.so

%files devel
%{_kde4_includedir}/kdewebkit_export.h
%{_kde4_includedir}/kgraphicswebview.h
%{_kde4_includedir}/kwebpage.h
%{_kde4_includedir}/kwebpluginfactory.h
%{_kde4_includedir}/kwebview.h
%{_kde4_includedir}/kwebwallet.h
%{_kde4_libdir}/kde4/devel/libkdewebkit.so
%{_kde4_libdir}/kde4/devel/libKDE4__kdewebkit.so


%changelog
* Mon Dec 07 2015 Rex Dieter <rdieter@fedoraproject.org> 4.14.8-1
- 4.14.8 (to match rhel7.2)

* Sat Jul 19 2014 Rex Dieter <rdieter@fedoraproject.org> 4.10.5-2
- rename .spec to match pkg Name:

* Fri Jun 20 2014 Rex Dieter <rdieter@fedoraproject.org> 4.10.5-1
- first try

